using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;

namespace ChartTool
{
    public partial class FormSColFX : Form
    
        // ab V. 7.8 drin
    {

        Chart chart1;
        Chart2D meinMain;

        public FormSColFX(Chart2D ch)
        {
            InitializeComponent();
            meinMain = ch;
            chart1 = ch.chart1;
        }

        Color[] colInternal = new Color[10]; // Zwischenspeicher fr Paletten

        private void buttongetcol_Click(object sender, EventArgs e)
        {
            panel1.BackColor = chart1.Series[0].Color;
            colInternal[0] = chart1.Series[0].Color;
            if (chart1.Series.Count > 1)
                panel2.BackColor = chart1.Series[1].Color;
            if (chart1.Series.Count > 2)
                panel3.BackColor = chart1.Series[2].Color;
            if (chart1.Series.Count > 3)
                panel4.BackColor = chart1.Series[3].Color;
            if (chart1.Series.Count > 4)
                panel5.BackColor = chart1.Series[4].Color;
            if (chart1.Series.Count > 5)
                panel6.BackColor = chart1.Series[5].Color;
            if (chart1.Series.Count > 6)
                panel7.BackColor = chart1.Series[6].Color;
            if (chart1.Series.Count > 7)
                panel8.BackColor = chart1.Series[7].Color;
            if (chart1.Series.Count > 8)
                panel9.BackColor = chart1.Series[8].Color;
            if (chart1.Series.Count > 9)
                panel10.BackColor = chart1.Series[9].Color;
            if (chart1.Series.Count > 1)
                colInternal[1] = chart1.Series[1].Color;
            if (chart1.Series.Count > 2)
                colInternal[2] = chart1.Series[2].Color;
            if (chart1.Series.Count > 3)
                colInternal[3] = chart1.Series[3].Color;
            if (chart1.Series.Count > 4)
                colInternal[4] = chart1.Series[4].Color;
            if (chart1.Series.Count > 5)
                colInternal[5] = chart1.Series[5].Color;
            if (chart1.Series.Count > 6)
                colInternal[6] = chart1.Series[6].Color;
            if (chart1.Series.Count > 7)
                colInternal[7] = chart1.Series[7].Color;
            if (chart1.Series.Count > 8)
                colInternal[8] = chart1.Series[8].Color;
            if (chart1.Series.Count > 9)
                colInternal[9] = chart1.Series[9].Color;
            gbselcol.Visible = false;
        }

        short colnb = 1;

        void panelClick()
        {
            gbselcol.Visible = false;
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                colInternal[colnb - 1] = colorDialog1.Color;
                for (int i = 0; i < chart1.Series.Count; i++)
                    chart1.Series[i].Color = colInternal[i];
                meinMain.DrawLegend();
            }
        }


        private void panel1_Click(object sender, EventArgs e)
        {
            colnb = 1;
            panelClick();
            panel1.BackColor = colInternal[colnb - 1];
        }


        private void panel2_Click(object sender, EventArgs e)
        {
            colnb = 2;
            panelClick();
            panel2.BackColor = colInternal[colnb - 1];

        }

        private void panel3_Click(object sender, EventArgs e)
        {
            colnb = 3;
            panelClick();
            panel3.BackColor = colInternal[colnb - 1];
        }

        private void panel4_Click(object sender, EventArgs e)
        {
            colnb = 4;
            panelClick();
            panel4.BackColor = colInternal[colnb - 1];
        }

        private void panel5_Click(object sender, EventArgs e)
        {
            colnb = 5;
            panelClick();
            panel5.BackColor = colInternal[colnb - 1];
        }

        private void panel6_Click(object sender, EventArgs e)
        {
            colnb = 6;
            panelClick();
            panel6.BackColor = colInternal[colnb - 1];
        }

        private void panel7_Click(object sender, EventArgs e)
        {
            colnb = 7;
            panelClick();
            panel7.BackColor = colInternal[colnb - 1];
        }

        private void panel8_Click(object sender, EventArgs e)
        {
            colnb = 8;
            panelClick();
            panel8.BackColor = colInternal[colnb - 1];
        }
        private void panel9_Click(object sender, EventArgs e)
        {
            colnb = 9;
            panelClick();
            panel9.BackColor = colInternal[colnb - 1];
        }

        private void panel10_Click(object sender, EventArgs e)
        {
            colnb = 10;
            panelClick();
            panel10.BackColor = colInternal[colnb - 1];
        }


        private void LabelClick()
        {
            if (chart1.Series.Count >= colnb)
            {
                gbselcol.Visible = true;
                gbselcol.Text = "Change Color Curve " + colnb.ToString();
                Color actcol = chart1.Series[colnb - 1].Color;
                textBox1.Text = actcol.ToString();
                trackBar1.Value = actcol.R;
                trackBar2.Value = actcol.G;
                trackBar3.Value = actcol.B;
            }
        }

        private void label1_Click(object sender, EventArgs e)
        {
            colnb = 1;
            LabelClick();
        }


        private void label2_Click(object sender, EventArgs e)
        {
            colnb = 2;
            LabelClick();
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            Color newcol = Color.FromArgb(trackBar1.Value, trackBar2.Value, trackBar3.Value);
            textBox1.Text = newcol.ToString();
            chart1.Series[colnb - 1].Color = newcol;
            
            chart1.Invalidate();
            meinMain.DrawLegend();
            switch (colnb)
            {
                case 1: panel1.BackColor = newcol; break;
                case 2: panel2.BackColor = newcol; break;
                case 3: panel3.BackColor = newcol; break;
                case 4: panel4.BackColor = newcol; break;
                case 5: panel5.BackColor = newcol; break;
                case 6: panel6.BackColor = newcol; break;
                case 7: panel7.BackColor = newcol; break;
                case 8: panel8.BackColor = newcol; break;
            }
        }

        private void label3_Click(object sender, EventArgs e)
        {
            colnb = 3;
            LabelClick();
        }

        private void label4_Click(object sender, EventArgs e)
        {
            colnb = 4;
            LabelClick();
        }

        private void label5_Click(object sender, EventArgs e)
        {
            colnb = 5;
            LabelClick();
        }

        private void label6_Click(object sender, EventArgs e)
        {
            colnb = 6;
            LabelClick();
        }

        private void label7_Click(object sender, EventArgs e)
        {
            colnb = 7;
            LabelClick();
        }

        private void label8_Click(object sender, EventArgs e)
        {
            colnb = 8;
            LabelClick();
        }
        private void label14_Click_1(object sender, EventArgs e)
        {
            colnb = 9;
            LabelClick();
        }

        private void label15_Click_1(object sender, EventArgs e)
        {
            colnb = 10;
            LabelClick();
        }

 
  
        private void FormSColFX_Load(object sender, EventArgs e)
        {
            buttongetcol_Click(sender, e);
        }

        private void buttonLoadCP_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamReader myStream1 = new StreamReader(openFileDialog1.OpenFile());
                textBoxFile.Text = myStream1.ReadToEnd();
                int col;
                string help;
                int B1;
                int B2;
                int colR;
                int colG;
                int colB;
                for (int i = 0; i < 10; i++)
                {
                    help = textBoxFile.Lines[i];
                    B1 = help.IndexOf(" ");
                    B2 = help.IndexOf(" ", B1 + 1);
                    colR = Convert.ToInt16(help.Substring(0, B1));
                    colG = Convert.ToInt16(help.Substring(B1 + 1, B2 - B1 - 1));
                    colB = Convert.ToInt16(help.Substring(B2 + 1, help.Length - B2 - 1));
                    colInternal[i] = Color.FromArgb(colR, colG, colB);
                }
                for (int i = 0; i < chart1.Series.Count; i++)
                    chart1.Series[i].Color = colInternal[i];
                buttongetcol_Click(sender, e);
                meinMain.DrawLegend();
            }
        }

        public void LoadDefault()
        {
            StreamReader myStream1 = new StreamReader("default.colpal");
            textBoxFile.Text = myStream1.ReadToEnd();
            int col;
            //axChartfx1.OpenDataEx(def.COD_COLORS, 100, 100);// ignores ser / point-params
            //for (int i = 0; i < 8; i++)
            //{
            //    col = Convert.ToInt32(textBoxFile.Lines[i]);
            //    axChartfx1.set_Color((short)i, (uint)col);// works only with OpenDatEx()
            //}
            //axChartfx1.CloseData(def.COD_COLORS);
        }


        private void buttonSaveCP_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {// file contains 10 lines, each line contains number of color
                textBoxFile.Text = "";
                string col = panel1.BackColor.R.ToString() + " " + panel1.BackColor.G.ToString() + " " + panel1.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel2.BackColor.R.ToString() + " " + panel2.BackColor.G.ToString() + " " + panel2.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel3.BackColor.R.ToString() + " " + panel3.BackColor.G.ToString() + " " + panel3.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel4.BackColor.R.ToString() + " " + panel4.BackColor.G.ToString() + " " + panel4.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel5.BackColor.R.ToString() + " " + panel5.BackColor.G.ToString() + " " + panel5.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel6.BackColor.R.ToString() + " " + panel6.BackColor.G.ToString() + " " + panel6.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel7.BackColor.R.ToString() + " " + panel7.BackColor.G.ToString() + " " + panel7.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel8.BackColor.R.ToString() + " " + panel8.BackColor.G.ToString() + " " + panel8.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel9.BackColor.R.ToString() + " " + panel9.BackColor.G.ToString() + " " + panel9.BackColor.B.ToString();
                textBoxFile.AppendText(col + "\x0d" + "\x0a");
                col = panel10.BackColor.R.ToString() + " " + panel10.BackColor.G.ToString() + " " + panel10.BackColor.B.ToString();
                textBoxFile.AppendText(col);
                StreamWriter myStream1 = new StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
                myStream1.WriteLine(textBoxFile.Text);
                myStream1.Close();
            }

        }

        private void FormSColFX_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }




    }

}