﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ChartTool
{
    public partial class FormName : Form
    {
        UserControl ucmain;
        
        public FormName(UserControl m)
        {
            InitializeComponent();
            ucmain = m;
        }

        private void AbbruchButton_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            Close();
        }

        private void OKButton_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            Close();
        }

        private void NameTextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Enter in TextBox
            if (e.KeyChar == 13) //13 = Return
            {
                e.Handled = true; //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.OK;
                Close();
            }
            else if (e.KeyChar == 27) //27 = esc
            {
                e.Handled = true;  //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.Cancel;
                Close();
            }
        }
    }
}
