﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ChartTool
{
    //Deklaration der Ereignisparameter
    //Eigene Klasse (abgeleitet von EventArgs), die die Ereignisparameter beinhaltet,
    //hier die beiden Koordinaten (x,y)
    public class CoordClickEventArgs : EventArgs
    {
        //Koordinaten können nur ausgelesen werden (read-only)
        public double x { get; private set; }
        public double y { get; private set; }
        
        //Konstruktor der Klasse
        public CoordClickEventArgs(double _x, double _y)
        {
            this.x = _x;
            this.y = _y;
        }
    }

    public class CounterChangedEventArgs:EventArgs
    {
        public int Counter { get; private set; }

        public CounterChangedEventArgs(int _c)
        {
            this.Counter = _c;
        }
    }

}
